/*
 * vim: ts=4 nobackup
 */


#ifndef  __KEYMATRIXMANAGER_H__
#define  __KEYMATRIXMANAGER_H__


#include <stdint.h>
#include "KeyMatrixListener.H"


extern "C++" {
	namespace avelino {
		using namespace std;

		class KeyMatrixManager {
			protected:
				static const uint8_t STATUS_SELECT_ROW;
				static const uint8_t STATUS_READ_COLUMN;
				static const uint8_t STATUS_KEY_PRESSED;
				static const uint8_t STATUS_WAIT_KEY_RELEASE;
				uint8_t status;
				int8_t timerHandler;
				KeyMatrixListener *listener;
				uint8_t keyColumn;
				uint8_t keyRow;
				uint8_t waitCounter;
			public:
				KeyMatrixManager();
				void init(KeyMatrixListener &l);
				void run();
				virtual void configurePorts() = 0;
				virtual uint8_t getNumRows() = 0;
				virtual uint8_t getNumColumns() = 0;
				virtual void enableRow(uint8_t row) = 0;
				virtual bool getColumn(uint8_t column) = 0;
		};
	}
}


#endif  // __KEYMATRIXMANAGER_H__
