/*
 * vim: ts=4 nobackup
 */

#ifndef  __LEDMATRIXMANAGER_H__
#define  __LEDMATRIXMANAGER_H__


#include <stdint.h>


#define  BLINK_RATE  25    // 125 ms


extern "C++" {
	namespace avelino {
		using namespace std;

		class LedMatrixManager {
			protected:
				uint8_t width;
				uint8_t height;
				uint8_t y;
				int8_t timerHandler;
				uint8_t blinkCounter;
				bool blinkOn;
			public:
				LedMatrixManager(uint8_t w, uint8_t h);
				void init();
				void run();
				virtual uint8_t getDot(uint8_t x, uint8_t y) = 0;
				virtual void configurePorts() = 0;
				virtual void setRow(uint8_t row, bool v) = 0;
				virtual void setColumn(uint8_t column, bool v) = 0;
		};
	}
}


#endif  // __LEDMATRIXMANAGER_H__
