/*
 * vim: ts=4 nobackup
 */


#include <stdint.h>
#include "Timer.H"
#include "LedMatrixManager.H"


using namespace avelino;
using namespace std;


LedMatrixManager::LedMatrixManager(uint8_t w, uint8_t h) {
	this->width = w;
	this->height = h;
}


void LedMatrixManager::init() {
	this->y = this->height - 1;
	this->configurePorts();
	this->timerHandler = Timer::alloc();
	this->blinkOn = false;
	this->blinkCounter = 0;
}


void LedMatrixManager::run() {
	if (Timer::counter[this->timerHandler] > 0)
		return;
	if (this->blinkCounter == 0) {
		this->blinkCounter = BLINK_RATE;
		this->blinkOn = !this->blinkOn;
	}
	else
		this->blinkCounter--;
	this->setRow(this->y, false);
	this->y++;
	if (this->y == this->height)
		this->y = 0;
	this->setRow(this->y, true);
	for (uint8_t x = 0; x < this->width; x++) {
		uint8_t v = this->getDot(x, this->y);
		bool b = (v > 1) || ((v == 1) && this->blinkOn);
		this->setColumn(x, b);
	}
	Timer::counter[this->timerHandler] = 2;
}


