/*
 * vim: ts=4 nobackup
 */


#include <avr/io.h>
#include <stdint.h>
#include "MyKeyMatrixManager.H"


using namespace avelino;
using namespace std;


void MyKeyMatrixManager::configurePorts() {
	DDRF |= (1 << 7) | (1 << 6) | (1 << 5);  // A0, A1, A2 as output
	DDRB &= (uint8_t) ~(1 << 7);   // D11 as input
	DDRD &= (uint8_t) ~(1 << 6);   // D12 as input
	DDRC &= (uint8_t) ~(1 << 7);   // D13 as input
}


uint8_t MyKeyMatrixManager::getNumRows() {
	return 3;
}


uint8_t MyKeyMatrixManager::getNumColumns() {
	return 3;
}


void MyKeyMatrixManager::enableRow(uint8_t row) {
	if (row == 0) {
		PORTF &= (uint8_t) ~(1 << 7);
		PORTF |= (1 << 6) | (1 << 5);
	}
	else if (row == 1) {
		PORTF &= (uint8_t) ~(1 << 6);
		PORTF |= (1 << 7) | (1 << 5);
	}
	else if (row == 2) {
		PORTF &= (uint8_t) ~(1 << 5);
		PORTF |= (1 << 7) | (1 << 6);
	}
}


bool MyKeyMatrixManager::getColumn(uint8_t column) {
	if (column == 0)
		return ((PINB & (1 << 7)) == 0);
	else if (column == 1)
		return ((PIND & (1 << 6)) == 0);
	else if (column == 2)
		return ((PINC & (1 << 7)) == 0);
	else
		return false;
}


