/*
 * vim: ts=4 nobackup
 */


#include "TTTGameBoard.H"


using namespace avelino;
using namespace std;


void TTTGameBoard::init() {
	for (uint8_t i = 0; i < 10; i++)
		this->data[i] = 0;
}


void TTTGameBoard::set(uint8_t i, uint8_t v) {
	this->data[i] = v;
}


uint8_t TTTGameBoard::get(uint8_t i) {
	return this->data[i];
}


bool TTTGameBoard::isFinished() {
	for (uint8_t i = 1; i <= 9; i++) {
		if (this->data[i] == 0)
			return false;
	}
	return true;
}


void TTTGameBoard::show() {
}


void TTTGameBoard::copyFrom(TTTGameBoard &other) {
	for (uint8_t i = 0; i < 10; i++)
		this->data[i] = other.data[i];
}


uint8_t TTTGameBoard::getFirstAvailableMovement() {
	uint8_t ret = 0;
	for (uint8_t i = 1; i <= 9; i++) {
		if (this->data[i] == 0) {
			ret = i;
			break;
		}
	}
	this->lastAvailableMovement = ret;
	return ret;
}


uint8_t TTTGameBoard::getNextAvailableMovement() {
	uint8_t ret = 0;
	for (uint8_t i = (this->lastAvailableMovement + 1); i <= 9; i++) {
		if (this->data[i] == 0) {
			ret = i;
			break;
		}
	}
	this->lastAvailableMovement = ret;
	return ret;
}


uint8_t TTTGameBoard::getWinner() {
	if ((this->data[8] != 0) && (this->data[8] == this->data[1]) && (this->data[1] == this->data[6]))
		return this->data[8];
	if ((this->data[3] != 0) && (this->data[3] == this->data[5]) && (this->data[5] == this->data[7]))
		return this->data[3];
	if ((this->data[4] != 0) && (this->data[4] == this->data[9]) && (this->data[9] == this->data[2]))
		return this->data[4];

	if ((this->data[8] != 0) && (this->data[8] == this->data[3]) && (this->data[3] == this->data[4]))
		return this->data[8];
	if ((this->data[1] != 0) && (this->data[1] == this->data[5]) && (this->data[5] == this->data[9]))
		return this->data[1];
	if ((this->data[6] != 0) && (this->data[6] == this->data[7]) && (this->data[7] == this->data[2]))
		return this->data[6];

	if ((this->data[8] != 0) && (this->data[8] == this->data[5]) && (this->data[5] == this->data[2]))
		return this->data[8];
	if ((this->data[4] != 0) && (this->data[4] == this->data[5]) && (this->data[5] == this->data[6]))
		return this->data[4];
	return 0;
}


