/*
 * vim: ts=4 nobackup
 */


#ifndef  __TTTGAMEPLAYER_H__
#define  __TTTGAMEPLAYER_H__


#include <stdint.h>
#include "GamePlayer.H"
#include "TTTGameBoard.H"


extern "C++" {
	namespace avelino {
		using namespace std;

		class TTTGamePlayer : public GamePlayer {
			protected:
				bool taken[10];
				bool pairs[16];
				bool winner;
				uint8_t number;
				TTTGameBoard *board;
			public:
				void init(uint8_t n, TTTGameBoard &b);
				virtual void internalInit() = 0;
				void run(bool &moved);
				bool isWinner();
				uint8_t getNumber();
				virtual uint8_t getSpot() = 0;   // get spot 1..9 or 0 for no movement
		};
	}
}


#endif  // __TTTGAMEPLAYER_H__
