/*
 * vim: ts=4 nobackup
 */


#include "TTTGamePlayer.H"


using namespace avelino;
using namespace std;


void TTTGamePlayer::init(uint8_t n, TTTGameBoard &b) {
	this->number = n;
	this->board = &b;
	for (uint8_t i = 0; i < 10; i++)
		this->taken[i] = false;
	for (uint8_t i = 0; i < 16; i++)
		this->pairs[i] = false;
	this->winner = false;
	this->internalInit();
}


void TTTGamePlayer::run(bool &moved) {
	moved = false;
	uint8_t spot = this->getSpot();
	if (spot == 0)
		return;
	if (this->pairs[15 - spot])
		this->winner = true;
	else {
		for (uint8_t i = 1; i <= 9; i++) {
			if (this->taken[i] && ((i + spot) < 15))
				this->pairs[i + spot] = true;
		}
	}
	this->taken[spot] = true;
	this->board->set(spot, this->number);
	moved = true;
}


bool TTTGamePlayer::isWinner() {
	return this->winner;
}


uint8_t TTTGamePlayer::getNumber() {
	return this->number;
}


